<?php
require_once ASD_APPLICATION_PATH . '/controllers/Abstract/Metabox.php';

class Asd_Controller_MetaboxController
    extends Asd_Controller_Abstract_Metabox
{
    public function indexAction()
    {
        $post = $this->getParam(0);
        $postId = $post->ID;


        $form = Asd_Application::getForm('Metabox')
            ->setPostId($postId)
            ->load();

        $errors = array();
        try {
            $form->loadCategories();
        } catch (Asd_Model_Amazon_Exception $e) {
            $errors[] = $e->getMessage();
        }

        $meta = Asd_Application::getModel('PostMeta')->setPostId($postId);
        $formErrors = $meta->getValue('errors');
        if ($formErrors && is_array($formErrors)) {
            $errors = array_unique(array_merge($errors, $formErrors));
        }
        $meta->unsetValue('errors');

        return array(
            'form' => $form,
            'post' => $post,
            'postId' => $postId,
            'errors' => $errors,
        );
    }

    public function handleSavePostAction()
    {
        $this->setViewScript(NULL);

        $postId = $this->getParam(0);
        $data = $this->getParam(1);

        // Unpack dialog data
        if (isset($data['dialog_data'])) {
            parse_str($data['dialog_data'], $dialogData);
            $formName = Asd_WpPlugin::PREFIX . '_metabox';
            if (isset($dialogData[$formName])) {
                $data = array_merge($data, $dialogData[$formName]);
            }
            unset($data['dialog_data']);
        }

        $form = Asd_Application::getForm('Metabox')
            ->setPostId($postId)
            ->load()
            ->loadCategories($data);

        $errors = array();
        try {
            if ($form->isValidEx($data)) {
                $form->save();
            } else {
                foreach ($form->getElements() as $element) {
                    foreach ($element->getMessages() as $message) {
                        $errors[] = "{$element->getLabel()}: {$message}";
                    }
                }
            }
        } catch (Asd_Model_Amazon_Exception $e) {
            $errors[] = $e->getMessage();
        }

        $meta = Asd_Application::getModel('PostMeta')->setPostId($postId);
        if ($errors) {
            $meta->setValue('errors', $errors);
        } else {
            $meta->unsetValue('errors');
        }
    }
}