<?php
require_once ASD_APPLICATION_PATH . '/services/View/Helper/AbstractHelper.php';

class Asd_Service_View_Helper_LimitWordCount extends Asd_Service_View_Helper_AbstractHelper
{
    public function __invoke($string, $limit, $elipsis='...')
    {
        $string = wp_check_invalid_utf8($string, TRUE);

        $words = preg_split('~[^\p{L}\p{N}\']+~u', $string, -1,
            PREG_SPLIT_OFFSET_CAPTURE|PREG_SPLIT_NO_EMPTY);

        $count = count($words);

        if ($count <= $limit) {
            return $string;
        }

        $last = $words[$limit-1];
        $string = substr($string, 0, $last[1] + strlen($last[0])) . $elipsis;

        return $string;
    }
}
